\chapter{Uncertainty modelling through random latent variables}
\label{chap:uncertainty-modelling}
Neural networks architectures are able to leverage huge amounts of data in order to infer millions of parameters, and produce accurate predictions.
Yet we cannot simply rely on their predictions being accurate when making decisions impacting well being and health.
In the previous chapter, we experimented with Hidden Markov Models (HMM) in an attempt to model the uncertainty associated with each prediction.
This approach is able to model the distribution of the observations instead of simply producing a prediction.
By analyzing it, we can derive information about the uncertainty of the model.
However, unlike neural networks, the training procedure of HMM does not scale well to numerous parameters in deep architectures, leading to degraded accuracy.

The main challenge we address in this chapter consists in combining the accuracy of neural networks with uncertainty modelling.
For this, we propose two approaches.
In Section~\ref{sec:decoupled-model}, we propose to decouple representation learning from uncertainty modelling, in a two step training procedure.
The unknown parameters are estimated by minimizing a deterministic cost function, then the last layer of the architecture is finetuned using Sequential Monte Carlo (SMC) methods.
The results presented are adapted from the following contribution: \textit{Last layer state space model for representation learning and uncertainty quantification}, Cohen, M., Charbit, M. and Le Corff, S., 2023 IEEE Statistical Signal Processing Workshop.
In Section~\ref{sec:chap2-vadiltis}, we develop a model with a discrete latent representation of the data.
We show that discrete regimes allow better interpretability of the model.
Additionally, parameter estimation does not require the complex approximations that come with continuous latent vectors, and is achieved through Variational Inference.
The results presented are adapted from the following contribution: \textit{Variational Discrete Latent Representation for Time Series Modelling}, Cohen, M., Charbit, M. and Le Corff, S., 2023 IEEE Statistical Signal Processing Workshop.

\section{Motivations}
The metamodel has proven to be an accurate surrogate  of TRNSYS for indoor temperature and consumption modelling and has provided interesting practical performance for several buildings, see Chapter~\ref{chap:metamodel}.
However, as real buildings behaviors are often much more complex than the simplified models written using TRNSYS, our model is still not able to closely match a huge variety of historic building data, during calibration for instance.
This can be explained by many factors: a monozone simplified model is not realistic to describe all buildings, the noise incurred from sensors and captors are not taken into account in the metamodel training, and the building faces many random solicitations such as the actions of its occupants.
The same factors can explain the limited performance when modelling relative humidity in the previous chapter.
%Because we introduced a very simple latent state space model, and did not account for observation noise, our initial approach could not match the complex historic data.

Although neural networks have been developed to solve many predictive tasks, they often solely output a single-point estimate, so that no uncertainty measure is available to provide statistical guarantees on their predictions.
Designing deep models and training associated procedures to estimate  predictive distributions of future observations is a long standing challenge.
These distributions could naturally be used to compute several uncertainty measures and validate the model or metamodel predictions, or highlight situations in which the predictions cannot be trusted for critical practical applications.
On the other hand, understanding better the uncertainty would help in introducing new models or new training procedures to improve the performance in large-scale real-world machine learning applications.

In this chapter, we propose a new approach to provide a flexible statistical framework that can be combined with deep learning architectures, taking into account stochastic latent states and noisy observations.
One of the main challenges of this approach resides in the dimension of our statistical models: in order to compute abstract features from the input data, deep neural networks often rely on hundred of thousands of parameters.
While there exists various methods for uncertainty estimation, fitting such large networks requires additional steps, that we introduce  in the following sections.

\section{Review of the literature}
Recurrent Neural Networks (RNN) were first introduced as an efficient and convenient architecture to address short time dependencies problems.
They have been consistently improved to develop longer term memory, and optimize their implementations \cite{Bengio1994LearningLD,Hochreiter1997LongSM}. %,Cho2014LearningPR}.
Current deep learning frameworks allow stacking arbitrary high number of recurrent layers, whose parameters are estimated by gradient descent through automated differentiation procedures, as shown in \cite{Graves2013SpeechRecognition}.
% However, many critical applications, such as medical diagnosis or drug design discovery, require not only accurate predictions, but a good estimate of their uncertainty (\cite{Crowson2016AssessingCalibration, Mervin2020UncertaintyQuantification}).
Fostering the dissemination of deep learning-based algorithms to such fields requires to design new approaches for uncertainty quantification.

\paragraph{Stochastic Recurrent Neural Networks. }
Bayesian statistics are able to approximate the distributions of future observations and to provide uncertainty estimation \cite{Hinton1995BayesianLF}.
Several architectures inspired by Variational Inference (see \cite{Jordan2004AnIT} for an introduction) emerged by considering latent states as random variables and approximating their posterior distribution.
The authors of \cite{Chung2015NIPS,10.5555/3157096.3157343} built on a traditional recurrent architecture by modelling temporal dependencies between these latent random states. Results presented in \cite{Fortunato2017bayesian} yield improved performance when considering local gradient information for computing the posterior.

Sequential Monte Carlo (SMC) methods have also been successfully applied to Recurrent Neural Networks.
Instead of computing a single latent vector at each time step, a set of particles representing the distribution of the latent space are propagated, and associated with importance weights.
In \cite{maddison2017filtering,naesseth2017variational}, the authors were able to model complex distributions on dependant data.
The parameters of the RNN are estimated through Variational Inference.

In \cite{Blundell2015}, the authors considered weights as random variables and proposed approximations of their posterior distributions allowing more robust predictions. Such Bayesian neural networks have been proposed and studied in a variety of works, see for instance \cite{hernandez2015probabilistic,khan2018fast,teye2018bayesian}. However, these methods are computationally intensive for high dimensional models and we do not have statistical guarantees on their ability to capture the target posterior distribution, see \cite{NEURIPS2020_b6dfd418}.

\paragraph{Ensemble methods. }
%Variational methods display encouraging results for modelling uncertainty in existing models, but require significant alteration of the model, as well as its training mechanism.
Monte Carlo Dropout (MC Dropout) methods offer to capture uncertainty by leveraging Dropout during both training and evaluation tasks, producing variable predictions from a single trained recurrent model, see \cite{Gal2016NIPS}.
In the recent years, MC Dropout methods have been applied in many industrial fields, such as flight delay prediction \cite{Vandal2018} or molecular simulations \cite{Wen2020UncertaintyQI}.
Alternatively, ensemble methods consist in training distinct networks to obtain a combined prediction, as shown in \cite{Pearce2018,Lakshminarayanan2017Ensemble}.
However, these frequentist approaches fail to guarantee proper calibration of the model, as highlighted by \cite{ashukha2020pitfalls}, and suffer various limitations, see \cite{Fong2020}.

\paragraph{Decoupled architectures. }
In an effort to provide an alternative strategy with limited computation overhead, \cite{Brosse2020OnLA} suggests splitting training in two stages to solve classification problems for independent data: representation learning and uncertainty estimation.
The two steps proceed as follows: (i) the algorithm first trains a deep classifier to obtain accurate task-dependent representations of the data, and then (ii) ensemble models are trained using these representations and the output.
Their experiments indicate that last-layer algorithms outperform baseline networks and that a single last layer is an appealing trade-off between computational cost and uncertainty quantification.
However, this method is restricted to independent and identically distributed data and cannot be directly applied to time series.



\section{Problem definition}
\label{sec:dataset_uncertainty}
Before considering uncertainty quantification for the end-to-end process associated with training a metamodel and solving calibration and optimization tasks, we propose in this chapter a solution to model predictive distributions for generic deep recurrent  neural networks. %We first evaluate the proposed model and training procedure  on a simple one dimensional task, in order to easily visualize, compare and interpret their predictions.
We model the distribution of a series of observations $(y_k)_{k=1}^T$, with the objective of both improving on the results of the previous chapter, presented in Table~\ref{tab:airq:naive_comparison}, and providing uncertainty quantification.
At each time step $k$, we store exogenous variables in a deterministic vector $u_k$.
The sample length $T$ is fixed.

Additionally to the Relative Humidity dataset, aggregated by Oze-Energies over two years, we also consider  a publicly available dataset in order to propose reproducible results.
Both datasets are treated similarly, in terms of model definition, training procedure and evaluation metrics.

\paragraph{Relative Humidity dataset. }
This dataset is composed of hourly records of indoor Relative Humidity (RH), from a building managed by Oze-Energies.
Our input data is comprised of the outdoor humidity, temperature and current occupancy.
Although occupancy is not directly observed by Oze-Energies, we do have access to \coo concentration at each time step, which we use as a surrogate variable.
We chose to split the dataset in day long samples, where $T=24$ .

Two years worth of data, namely for 2020 and 2021, are available.
Note that the lockdown from the COVID-19 happened in April 2020, and had a strong impact on both \coo and RH as the building was completely empty during this period.
In Figure~\ref{fig:airq:dataset}, where we plotted the entirety of the dataset for both input variables and target observations, we can see how occupation slowly rose after the lockdown, as highlighted by the growing \coo levels during occupancy times.
For this reason, the first year and a half was used for training, and the remaining of the dataset was saved for validation.

\paragraph{Electricity Transformer Dataset. }
\label{par:chap3-etdataset}
The Electricity Transformer Dataset (ETDataset) records the evolution of oil temperature in electricity transformers in order to better understand and model their state.
A good estimation of the future oil temperature could help reduce energy waste.
The dataset was introduced in \cite{Zhou2021Informer}, and was released publicly\footnote{https://github.com/zhouhaoyi/ETDataset/}.
Oil temperature records, which we aim to model, are associated with six power load features: High Useful Load (HUFL), High Useless Load (HULL), Middle Useful Load (MUFL), Middle Useless Load (MULL), Low Useful Load (LUFL) and Low Useless Load (LULL).

Once again, we have two years worth of hourly data, displayed in Figure~\ref{fig:dataset_ETDataset} where we plotted inputs and outputs.
Following the original paper, we train our models on samples from the first year, and validate on samples from the following four months.

\begin{figure}[htpb]
	\centering
	\caption{Visualization of a 4-week sample of the Electricity Transformer dataset from \cite{Zhou2021Informer}, and presented in Paragraph~\ref{par:chap3-etdataset}.
		We only plotted the input variables HUFL and MULL for better clarity, as well as the observations (Oil Temperature).}
	\includegraphics[width=0.8\linewidth]{images/airq/energy_transformer_dataset.png}
	\label{fig:dataset_ETDataset}
\end{figure}

\section{Monte Carlo approach for continuous latent}
\label{sec:decoupled-model}
Inspired by \cite{Brosse2020OnLA}, we propose a last layer approach to split uncertainty quantification from representation learning, in the context of dependent data.
This new method for uncertainty estimation combines high expressivity, quality uncertainty estimations and ease of training.
Our proposed architecture is composed of an arbitrary sequential model, followed by a decoupled state space model layer.
Using a state space model in the last layer allows to introduce complex predictive distributions for the observations based on task-dependent latent data.
However, because the loglikelihood of the observations is not available explicitly in such a setting, the second stage training requires using approximate sampling methods.

Estimating the parameters of potentially high-dimensional models with unobserved (i.e. noisy) layers is a challenging task.
We therefore propose to first train an input model following traditional deep learning approaches, then use Sequential Monte Carlo methods in a lower dimensional state space to account for uncertainty, with tractable and computationally efficient simulation-based methods.
The two-stage training algorithm is presented in Algorithm~\ref{alg:particle_filter}, and the architecture of the model is described in Figure~\ref{fig:lastlayer_proposed_architecture}

\subsection{Related works}
\subsubsection{Sequential Monte Carlo Methods for recurrent neural networks}
They are many approaches to model uncertainty in statistical models.
We present an architecture based on Sequential Monte Carlo methods, an application of Monte Carlo algorithms for time dependent data.
They have been successfully combined with recurrent neural networks to tackle variable sequential problems, see for instance \cite{naesseth2017variational,maddison2017filtering,Ma2020}.
We turn to \cite{Martin2020TheMC} for an example using more complex neural architectures, such as the Transformer.
Particle filters have also proven reliable in other fields, such as presented in \cite{Liu2020LSTMPF} for object tracking.
These methods however do not scale to high dimension latent space, where computations quickly become intractable and inefficient.

\subsubsection{Two-stage training}
Our two stage training procedure is inspired by Transfer Learning, a well known deep learning technique which consists in producing a first estimate of the parameters using a computationally cheap  related task.

With deeper and deeper neural network architectures, come the need for bigger datasets and more complex training procedures, which themselves come at a high price: obtaining data can be expensive, and may require additional labeling ; heavy computations for extended periods usually incur costly infrastructure.
Transfer learning first appeared with the realization that the first layers are often almost identical from one model to the next, regardless of the precise task they were trained for, as shown in \cite{Yosinski2014TransferLearning}.
Another major highlight from this paper is that initializing parameters with an auxiliary task can improve generalization performance.

Many works have shown the practical use of Transfer Learning in diverse fields of application.
A first estimate of the parameters is obtained from publicly available models, trained on generic tasks, or by training a new model on a public dataset.
Then, the parameters - or a subset - are finetuned on a smaller scale dataset, see \cite{Pan2010Survey} for a review.
This method is flexible, as it allows changing the architecture of the model, as well as removing or adding new layers between the pre-training and fine-tuning steps, see \cite{Chouhan2020} for an example applied to Computer Vision or \cite{Raffel2020TransferLearning} to Natural Language Processing.

Transfer Learning is an essential part of our proposed architecture.
Since estimating all parameters of a deep neural network using Sequential Monte Carlo methods would be computationally prohibitive, we first train the first layers of our model on a simple regression task.
In a second stage, the parameters of the last layer can be finetuned on a more complex uncertainty modelling task.


\subsubsection{Representation learning}
Our objective is to take advantage of the recent efforts in deep neural network design, and training, to abstract huge amounts of complex, intricate data.
The authors of \cite{Hinton2006ReducingDimensionality} demonstrated that high dimensional data can be represented in a much lower space using deep neural architectures, and proposed an autoencoder model to this end, see Figure~\ref{fig:lastlayer_autoencoder}.
In \cite{Bengio2007LearningDA}, it is further shown that more complex data may require deeper architectures to obtain low dimensional representations.
On a practical experimentation with samples in a 220 dimension space, the authors of \cite{Alkhayrat2020ACD} concluded that deep neural networks outperformed traditional algorithms for dimensionality reduction, such as the Principal Component Analysis.
In all these references, the huge number of parameters arising from deep neural network architectures where estimated using gradient descent.

By implementing such models, we aim at representing our potentially high dimensional input data in a smaller latent space.
There, our Sequential Monte Carlo algorithm is be able to efficiently model uncertainty.

\begin{figure}[htpb]
	\centering
	\caption{An autoencoder architecture for dimensionality reduction using deep neural networks.
	The input vectors are mapped to a lower dimension space using the Encoder, and represented as encoded vectors, here in the middle of the diagram.
	The Decoder learns the inverse transformation, in order to reconstruct the original input vectors.
	Both the Encoder and Decoder are non linear parametric functions, usually a combination of well known deep learning layers.}
	\includegraphics[width=0.5\linewidth]{images/airq/auto_encoder_archi.png}
	\label{fig:lastlayer_autoencoder}
\end{figure}

\subsection{Proposed architecture}%
\label{sec:chap2-decoupled-architecture}
In the following, for any sequence $(a_m,\ldots, a_n)$ with $n\geq m$, we use the short-hand notation $a_{m:n} = (a_m,\ldots, a_n)$.
\subsubsection{Input model}
We first consider an arbitrary multi-layer neural network $h_\phi$ with unknown parameters $\phi$, responsible for transforming the input time series $u_{1:T}$ into high level features $\widetilde u_{1:T}$, in a small dimension latent space:
\begin{align*}
	\widetilde u_{1:T} & = h_\phi(u_{1:T})\,, & \text{input model.}
\end{align*}
We produce an estimate $\hat \phi$ during the first training stage, by introducing an auxiliary function $\kappa_\psi$ to model the observations as follows: for all $1 \leq t \leq T$, $y_t = \kappa_\psi(y_{t-1}, \widetilde u_t) + \epsilon_t$ and $y_0 = \kappa_\psi(\widetilde u_0) + \epsilon_0$, where $(\epsilon_t)_{t\leq 0}$ are i.i.d. centered Gaussian random variables with unknown variance $\Sigma$.
The input model is trained on a simple deterministic regression task, by performing gradient descent on the mean squared error, leading to a first estimate of $\phi$ and $\psi$.
We keep the estimated parameters $\hat \phi$ while the auxiliary function $\kappa_\psi$ and its parameters, only designed to model the observations, are discarded.

\subsubsection{State space model}
\label{sub:lastlayer_proposed_architecture}
The next step is to define a state space model taking as input the previously extracted features $\widetilde u_{1:T}$.
Let $x_{1:T}$ a sequence of stochastic hidden states computed recursively and $y_t$ their associated predictions.
For all $t \geq 1$, the model is defined as:
\begin{align*}
	x_t & = g_\theta(x_{t-1}, \widetilde u_t) + \eta_t\,, & \text{state model, }       \\
	y_t & = f_\theta(x_t) + \varepsilon_t\,,              & \text{observation model, }
\end{align*}
where $\theta$ are the unknown real-valued parameters of the network (weights and biases) and $f_\theta$ and $g_\theta$ are nonlinear parametric functions.
We chose $(\eta_t)_{t\geq 1}$ and $(\varepsilon_t)_{t\geq 1}$ as two independent sequences of i.i.d. centered Gaussian random variables with covariance matrices $\Sigma_x$ and $\Sigma_y$, although any distribution can be substituted to better match the noise distribution.

This decoupled approach aims at reducing the number of parameters in $\theta$, compared to $\phi$, in order to estimate them using Sequential Monte Carlo methods.
In the next section, we describe this second training procedure for estimating the last layer parameters $\theta$ only, by keeping $\hat \phi$ fixed.
All implementation and training details are postponed to Section~\ref{sub:lastlayer_experiments}.

\begin{figure}[htpb]
	\centering
	\caption{Our architecture combining a generic input model with a state space model on the last layer.}
	\includegraphics[width=0.4\linewidth]{images/airq/lastlayer/architecture.png}
	\label{fig:lastlayer_proposed_architecture}
\end{figure}

\subsection{Sequential Monte Carlo Layer}%
\label{sub:lastlayer_uncertainty_estimation}
In this section, we detail how to estimate the parameter $\theta$ of the model introduced in Section~\ref{sub:lastlayer_proposed_architecture}, from a record of observations $y_{1:T}$.
%Note that $\Sigma_x$ and $\Sigma_y$ are estimated using the same approximation, by computing an explicit update rule presented in the next chapter.
Unlike deterministic neural networks, the likelihood $L$ of the observations is not available explicitly, as it would require integrating over the distribution of the hidden states $x_{1:T}$:
$$
	L : \theta \mapsto \int p_\theta(y_{1:T}, x_{1:T}) \mathrm d x_{1:T},
$$
where $p_\theta$ is the joint probability density function of the observations and the hidden states.
Consequently, the score function $\theta \mapsto \nabla_\theta \log L(\theta)$ is intractable, and automated differentiation cannot be used directly.
We propose to optimize instead a Monte Carlo estimator of this score function, using Fisher's identity, see for instance  \cite{monographie-randal}:
\begin{equation}
	\nabla_\theta \log p_\theta(y_{1:T}) = \mathbb{E}_\theta \left[ \nabla_\theta\log p_\theta(x_{1:T}, y_{1:T}) | y_{1:T} \right]\,,
	\label{eq:grad_ll}
\end{equation}
where $\mathbb{E}_\theta$ designs the expectation under the model parameterized by $\theta$ (the dependency on the input $u_{1:T}$ is kept implicit here for better clarity).
The conditional distribution of $x_{1:T}$ given $y_{1:T}$ is not available explicitly for a nonlinear state space model, but it can be approximated using a sequential Monte Carlo smoother. A classical approach consists in first iteratively approximating the filtering distributions $p_\theta(x_{t} | y_{1:t})$, for $t \leq T$, by a set of $N$ particles $(\xi^{\ell}_t)_{1 \leq t \leq T, 1 \leq \ell \leq N}$.
Then, the smoothing distribution $p_\theta(x_{1:T}|y_{1:T})$ can be approximated by associating importance weights $(\omega^{\ell}_T)_{\ell=1}^N$ with each particle genealogy $(\xi^{\ell}_{1:T})_{\ell=1}^N$.
In the following paragraphs, we denote by $\Psi_{\mu, \Sigma}$ the Gaussian probability density function with mean vector $\mu$ and covariance matrix $\Sigma$.

\subsubsection{Particle filter}
We now present a standard particle filter.
At $t = 0$, $(\xi^{\ell}_0)_{\ell=1}^N$ are sampled independently from $\rho_0 = \Psi_{0, \Sigma_x}$, and each particle $\xi^{\ell}_0$ is associated with the standard importance sampling weight:
\[
	\omega_0^{\ell} \propto  \Psi_{Y_0, \Sigma_y}(f_\theta(\xi^{\ell}_0)) \,.
\]
%where $\ell_0(\cdot) = \Psi_{Y_0, \Sigma_y}(f_\theta(\cdot))$.
Then, for $t\geq 1$, using $\{(\xi^{\ell}_{t-1},\omega^{\ell}_{t-1})\}_{\ell=1}^N$,  pairs $\{(I^{\ell}_t,\xi^{\ell}_t)\}_{\ell=1}^N$ of indices and particles are sampled from the instrumental distribution:
\[
	\pi_t(\ell,x) \propto \omega_{t-1}^{\ell} p_t(\xi^{\ell}_{t-1}, x)\,.
\]
In this application we use for $p_t(\xi^{\ell}_{t-1}, \cdot)$ the prior kernel $\Psi_{g_\theta(\xi^\ell_{t-1}, \tilde u_t), \Sigma_x}$.
For $\ell \in \{1,\ldots,N\}$, $\xi^{\ell}_t$ is associated with the importance weight $\omega^{\ell}_t \propto \Psi_{Y_t, \Sigma_y}(f_\theta(\xi^{\ell}_t))$.
An application of this algorithm is presented in Figure~\ref{fig:particle_filter} on a toy model. Such a particle filter with multinomial resampling is referred to as the bootstrap algorithm, see \cite{gordon1993novel}. It has been extended and analyzed in many directions in the past decades, see \cite{pitt1999filtering,douc2005comparison,Chopin_2020}. In other lines of works, the adaptive tuning of the Monte Carlo effort has been analyzed in order to  adapt the
number of particles on-the-fly, see \cite{elvira2016adapting,elvira2021performance}.


\subsubsection{Path-space particle smoother}
Any particle smoother can be used to estimate \eqref{eq:grad_ll} such as the Path-space smoother \cite{Kitagawa1996}, the Forward Filtering Backward Smoothing \cite{Doucet2000OnSM} or the Forward Filtering Backward Simulation algorithm \cite{Godsill2004MonteCS}.
Additionally, because estimating \eqref{eq:grad_ll} amounts to computing a smoothed expectation of an additive functional, we can also use very efficient forward-only SMC smoothers such as the PaRIS algorithm and its pseudo-marginal extensions \cite{Olsson2014EfficientPO,gloaguen2022pseudo}.

In order to illustrate our approach with the simplest (and computationally cheapest) SMC smoother, consider first the Path-space smoother.
The genealogical trajectories are defined recursively and updated at each time step with the particles and indices $(\xi^\ell_{t+1}, I^\ell_{t+1})$: for all $0 \leq t \leq T - 1$,
$$\xi^\ell_{0:t+1} = \left(\xi^{I^\ell_{t+1}}_{0:t}, \xi^\ell_{t+1}\right)$$
In Figure~\ref{fig:particle_filter}, the $N = 3$ genealogical trajectories are:
$$\xi^1_{0:4} = (\xi^3_0 , \xi^2_1 , \xi^2_2 , \xi^3_3 , \xi^1_4),\; \xi^2_{0:4} = (\xi^3_0 , \xi^1_1 , \xi^3_2 , \xi^2_3 , \xi^2_4),\; \xi^3_{0:4} = (\xi^3_0 , \xi^2_1 , \xi^2_2 , \xi^3_3 , \xi^3_4).$$
The score function \eqref{eq:grad_ll} can then be estimated as follows:
$$
	\widehat {S}^N_\theta(y_{1:T}) = \sum_{\ell=1}^N \omega_T^\ell\nabla_\theta\log p_\theta(\xi^\ell_{1:T}, y_{1:T})\,,
$$
where $p_\theta$ is the joint probability density function of $(x_{1:T}, y_{1:T})$ for the model described in Section~\ref{sub:lastlayer_proposed_architecture}.
Using automated differentiation, we can perform gradient descent on the parameter $\theta$.

\begin{figure}[htpb]
	\centering
	\caption{The auxiliary particle filter for $N=3$ and $T=4$. In blue are the particles sampled for the last time step. Each particle from a previous time step belonging to their genealogy is colored in pink. The others, in white, will be discarded.}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/particle_filter.png}
	\label{fig:particle_filter}
\end{figure}

\subsubsection{Online extensions and the PaRIS}
Although simple and computationally cheap, the smoother  based on the ancestral lines of each particle may provide poor estimators. The resampling steps deplete the ancestor lines and, as time increases,  two different particles are likely to originate from the same ancestors in the first time steps. The Monte Carlo estimator then suffers generally from high variance when  estimating joint-smoothing expectations as in the score estimation problem.

This degeneracy relative to the smoothing problem can be overcome using
\emph{backward sampling}. It is specifically designed for additive functionals so it is well suited to our setting \eqref{eq:grad_ll} where
$$
	\nabla_\theta\log p_\theta(x_{1:T}, y_{1:T}) = \sum_{s=1}^T \left\{\nabla_\theta \log m_{\theta}(x_{t-1},\widetilde u_t;x_t) + \nabla_\theta \log r_{\theta}(x_{t},y_t)\right\}\,,
$$
where $m_{\theta}(x_{t-1},\widetilde u_t;\cdot)$ is the transition density of the state model and $r_{\theta}(x_{t},\cdot)$ is the density of the conditional distribution of $y_t$ given $x_t$ and by convention $m_{\theta}(x_{0},\widetilde u_1;\cdot) = \rho_0(\cdot)$.

Appealingly, using the path-space smoother  described in the previous section, a Monte Carlo estimator of the score function can be obtained online  by setting,
\begin{equation} \label{eq:def:PaRIS:score}
	\widehat {S}^N_\theta(y_{1:T}) = \sum_{i = 1}^N \omega_T^i\tau_T^i,
\end{equation}
where the statistics $\{\tau_s^i\}_{i = 1}^N$ satisfy the recursion
\begin{equation}
	\label{eq:pms:online}
	\tau_{s + 1}^{i} = \tau_{s}^{I_{s+1}^{i}} + \tilde{h}_s(\xi_{s}^{I_{s+1}^{i}}, \xi_{s + 1}^{i}),
\end{equation}
where
$$
	\tilde{h}_s(x_s,x_{s+1}) = \nabla_\theta \log m_{\theta}(x_{s},\widetilde u_{s+1};x_{s+1}) + \nabla_\theta \log r_{\theta}(x_{s+1},y_{s+1})\,.
$$
Note that the conditional probability that $I_{s+1}^{i} = j$ given the offspring $\xi_{s + 1}^{i}$ and the ancestors $\{\xi_{s}^{\ell}\}_{\ell = 1}^N$ is given by
\begin{equation} \label{eq:def:backwardkernel}
	\mathbf{\Lambda}_s(i, j) =  \frac{\omega_{s}^{j} m_\theta(\xi_{s}^{j}, \xi_{s+1}^{i})}{\sum_{\ell = 1}^N \omega_{s}^{\ell}m_\theta(\xi_{s}^{\ell}, \xi_{s+1}^{i})}.
\end{equation}
It is straightforward to note that $\mathbf{\Lambda}_s$ is a Markov transition kernel on $\{1,\ldots, N\} \times \{1,\ldots, N\}$.  The particle-path degeneracy of the path-space  smoother can be overcome by computing the expectation under the law of this kernel:
\begin{equation}
	\label{eq:ffbs:bwupdate}
	\tau_{s + 1}^{i} = \sum_{j = 1}^N \mathbf{\Lambda}_s(i,j) \{ \tau_{s}^{j} + \tilde{h}_s(\xi_{s}^{j}, \xi_{s+1}^{i})\}.
\end{equation}
This approach, first proposed in \cite{DelMoral2010}, avoids the path degeneracy as is eliminates the ancestral connection between the particles by means of averaging. Furthermore, it is entirely online. Still, a significant drawback is the overall $\mathcal{O}(N^2)$ complexity. Following \cite{Olsson2014EfficientPO}, we  propose to sample $M \ll N$ conditionally independent indices $\{ J^{i,j}_s \}_{j = 1}^M$ from the distribution $\mathbf{\Lambda}_s(i, \cdot)$ and to update the statistics according to
\begin{equation}
	\label{eq:ffbs:paris:score}
	\tau_{s + 1}^{i} = M^{-1} \sum_{j = 1}^M \left(\tau_{s}^{J^{i,j}_s} + \tilde{h}_s(\xi_{s}^{J^{i,j}_s}, \xi_{s + 1}^{i})\right).
\end{equation}
If the state transition density is uniformly bounded from above and below, an accept-reject approach allows the sampling-based update to be performed for $i \in \{1,\ldots,N\}$ at an $\mathcal{O}(N(M+1))$ overall complexity if a pre-initialized multinomial sampler is used. A key aspect of this approach is that the number $M$ of sampled indices at each step can be very small; indeed, for any fixed $M \geq 2$, the algorithm, which is referred to as the PaRIS, can be shown to be stochastically stable with an $\mathcal{O}(t)$ variance (see \cite[Section~1]{Olsson2014EfficientPO} for details), and setting $M$ to $2$ or $3$ yields typically fully satisfying results.

\subsubsection{Stochastic Gradient Descent for online estimation}
An appealing application of the last layer approach is recursive maximum likelihood estimation, i.e., where new observations are used only once to update the estimator of the unknown parameter $\theta$. In \cite{Brosse2020OnLA}, the authors used in particular Stochastic Gradient Descent (SGD) and Stochastic Gradient Langevin Dynamics to update the estimation of $\theta$ and perform uncertainty quantification. In state space models, recursive maximum likelihood estimation produces a sequence $\lbrace\theta_t\rbrace_{t\geq 0}$ of parameter estimates writing, for each new observation $y_{t},~t\geq 1$,
$$
	\theta_{t} = \theta_{t-1} + \gamma_t \nabla_\theta \ell_{\theta}(y_t | y_{0:t - 1}) \,,
$$
where $\ell_{\theta}(y_t | y_{0:t - 1})$ is the loglikelihood for the new observation given all the past, and $\lbrace\gamma_t\rbrace_{t\geq 1}$ are positive step sizes such that $\sum_{t \geq 1}\gamma_t = \infty$ and $\sum_{t \geq 1}\gamma_t^2 < \infty$.
A practical implementation of such an algorithm, where $\nabla_\theta\ell_{\theta}(y_t | y_{0:t - 1})$ is approximated using the weighted samples $\{(\xi^{\ell}_t,\omega^{\ell}_t)\}_{\ell=1}^N$ can be found for instance in \cite{gloaguen2022pseudo}.
The PaRIS algorithm proposed in \cite{Olsson2014EfficientPO} allows to use the weighted samples $\{(\xi^{\ell}_t,\omega^{\ell}_t)\}_{\ell=1}^N$ and the statistics $\{\tau^{\ell}_t\}_{\ell=1}^N$ on-the-fly to approximate $\nabla_\theta \ell_{\theta}(y_t | y_{0:t - 1})$ either using rejection sampling approaches or importance sampling steps. The update of the recursive maximum likelihood algorithm is based on:
\begin{equation}
	\nabla_\theta \ell_{\theta}(y_t | y_{0:t - 1})
	=  \frac{\pi_{t;\theta}[\nabla_\theta r_{t;\theta}] + \eta_{t;\theta}[r_{t;\theta}]}{\pi_{t;\theta}[r_{t;\theta}]},
	\label{eq:online:gradient}
\end{equation}
where $\pi_{t;\theta}$ is the predictive distribution at time $t$, i.e. the law of $x_t$ given $y_{0:t-1}$, $r_{t;\theta} = r_{\theta}(\cdot,y_t)$  and
$$\eta_{t;\theta}[r_{t;\theta}] = \phi_{0:t;\theta \mid t - 1} [h_{0:t;\theta} r_{t;\theta}] - \pi_{t;\theta}[r_{t;\theta}]  \phi_{0:t;\theta \mid k - 1 }[h_{0:t;\theta}],$$
with $\phi_{0:t;\theta \mid t - 1}$ the distribution of $x_{0:t}$ given $y_{0:t-1}$ and
\begin{equation}
\label{eq:complete:gradient:log}
h_{0:t;\theta}(x_{0:t}) =  \sum_{s = 0}^{t - 1} \nabla_\theta\log q_{s, \theta}(x_s,x_{s+1}),
\end{equation}
with $q_{s, \theta}(x_s,x_{s+1}) = r_{s, \theta}(x_{s+1})m_\theta (x_s,\widetilde u_{s+1};x_{s+1})$.
The signed measure $\eta_{t;\theta}$ is known as the \textit{tangent filter}.
%, see \cite[Chapter~10]{cappe2005inference}, \cite{delmoral2015uniform} or \cite{olsson2020particle}.
%Using the tower property  yields
% and the backward decomposition \eqref{eq:property:backward} yields
% \begin{align*}
% \post{0:k;\theta \mid k - 1} [\af{0:k;\theta} \md{k;\theta}]  &= \mathbb{E}_\theta\left[\af{0:k;\theta}(X_{0:k}) \md{k;\theta}(X_k)\middle|Y_{0:k-1}\right]\eqsp,\\
% &= \mathbb{E}_\theta\left[\mathbb{E}_\theta\left[\af{0:k;\theta}(X_{0:k}) \middle|X_k,Y_{0:k-1}\right]\md{k;\theta}(X_k)\middle|Y_{0:k-1}\right]\eqsp,\\
% &= \mathbb{E}_\theta\left[\tstat{k} [\af{0:k}](X_k) \md{k;\theta}(X_k)\middle|Y_{0:k-1}\right] =  \pred{k;\theta}\left[\tstat{k} [\af{0:k}]\md{k;\theta}\right]\eqsp,
% \end{align*}
%so that
% \begin{equation}
% \label{eq:tangent:identity}
% \eta_{t;\theta}[g_{t;\theta}] = \pi_{t;\theta}\left[\left(\tstat{k} [\af{0:k}] - \pi_{k;\theta}[\tstat{k}[\af{0:k}]]\right) g_{t;\theta}\right].
% \end{equation}
%It is worth noting that, in the context of this paper where $\qg{k}$ cannot be evaluated pointwise,  the functional \eqref{eq:complete:gradient:log} is unknown.
%In Section \ref{sec:simu:tangent:filter}, we illustrate that we can plug-in an estimate of this functional instead.
Recursive maximum likelihood  algorithms  rely on the following straightforward decomposition of the normalized loglikelihood:
$$
\frac{1}{n} \nabla_\theta \ell_{\theta}(y_{0:t-1}) = \frac{1}{t} \sum_{k = 0}^{t-1} \nabla_\theta \ell_{\theta}\left(y_k \mid y_{0:k - 1}\right),$$
with the convention $ \ell_{\theta}(y_0 \mid y_{0:-1}) = \ell_{\theta}(y_0)$. Under strong mixing assumptions, for all  $\theta$,  $\{ (X_n, Y_n, \pi_{n}, \eta_{n}) \}_{n \geqslant 0}$ is an ergodic Markov chain and the normalized score $\nabla_\theta \ell_{\theta}(y_{0:t-1})/t$  converges almost surely to a limiting quantity $\lambda(\theta, \theta_{\star})$ such that, under identifiability constraints, $\lambda(\theta_{\star}, \theta_{\star}) = 0$.
A gradient ascent algorithm cannot be designed as the limiting function $\theta \mapsto \lambda(\theta, \theta_{\star})$ is not available explicitly.
However, \emph{Robbins-Monro algorithm} can be used to solve approximately the equation $\lambda(\theta_{\star}, \theta_{\star}) = 0$ with iterative updates
\begin{equation}
\label{eq:par:update}
\theta_{t} = \theta_{t - 1} + \gamma_{t} \zeta_{t}, \quad t\geq 0,
\end{equation}
where $\zeta_{t}$ is a noisy observation of $\lambda(\theta_{t - 1}, \theta_{\star})$, equal to \eqref{eq:online:gradient}.
%In the case of a finite state space $\set{X}$ the algorithm was studied in~\cite{legland1997recursive}, which also provides assumptions under which the sequence $\{\theta_{n}\}_{n\geqslant 0}$ converges towards the parameter $\theta_{\star}$ (see also \cite{tadic2010analyticity} for refinements).

The objective is therefore to approximate the key quantity \eqref{eq:online:gradient}.
Using the particle filter, we can compute the Monte Carlo estimators:
$$
\pi_{t}^N[r_{t;\theta}] = \frac{1}{N}\sum_{\ell = 1}^N r_{t;\theta}(\xi_{t}^{\ell})\quad \mathrm{and} \quad \pi_{t}^N[\nabla_\theta r_{t;\theta}] = \frac{1}{N}\sum_{\ell = 1}^N \nabla_\theta r_{t;\theta}(\xi_{t}^{\ell}).
$$
In addition, the tangent filter can be approximated as follows:
\begin{equation}
\label{eq:tangent:identity:part:linear}
\eta_{t;\theta}^{N}[r_{t;\theta}] = \frac{1}{N}\sum_{\ell=1}^N\tau_t^\ell r_{t;\theta}
(\xi^{\ell}_{k}) - \left(\frac{1}{N}\sum_{\ell=1}^N\tau^\ell_t\right)\left(\frac{1}{N}\sum_{\ell=1}^N r_{t;\theta}(\xi^{\ell}_{t})\right).
\end{equation}
Plugging these estimates in equation \eqref{eq:online:gradient} allows to perform the online recursive algorithm.

Although this algorithm is very efficient to update parameters recursively, it is computationally intensive and therefore {\bf fits particularly well our last layer approach} as it would be {\bf intractable for very high dimensional latent states}.

\subsubsection{Discussion}
The proposed approach allows to adapt widespread Monte Carlo techniques to deep learning architectures, yet several questions arise from this methodology, due to the nature of particle smoothers and their implementation.

The Path-space smoother is known to quickly degenerate due to the successive resampling steps of the auxiliary filter.
During this step, if one of the particle is not selected to be propagated, i.e. for each time step $t$, if there exists $i \in \{1, \cdots N\}$ such that for all $1 \leq j \leq N, I_t^j \neq i$, then the particle's genealogy is discarded for the rest of the process.
Over many time steps, the smoother degenerates as most particles share the same genealogy.
In Figure~\ref{fig:particle_filter}, the trajectories $\xi_{0:4}^1$ and $\xi_{0:4}^3$ share the same history.
Although this limitation can be mitigated by using recent alternatives such as the PaRIS, this raises the question of trade-off between the additional complexity (coming from the $M$ backward samples) and the accuracy of the score estimate.

In addition even the Path-space smoother comes at a heavy computation cost with simulating $N$ trajectories at once.
Even for modern processing units, such as the GPU able to parallelize hundreds of matrix multiplications, computation times are bound to increase.
It is also noteworthy that the smoothing algorithm, although relatively lightweight compared to running inferences on the neural network or computing gradient descent, cannot be parallelized.
Lastly, the number of particles $N$ is an additional hyper parameter to tune during the optimization of the model.

\begin{algorithm}
	\caption{Two-stage learning}
	\label{alg:particle_filter}
	\KwIn{$y_{1:T}, u_{1:T}$}
	\KwOut{$(\hat \phi, \hat \theta)$}
	$\hat \phi \gets$ Train the input model $h_\phi$\;
	$\widetilde u_{1:T} \gets h_{\hat \phi}(u_{1:T})$\;
	Initialize parameter estimate $\widehat \theta_0$\;
	\For{$p \gets 1$ \KwTo $\mathrm{MaxIt}$}{
	$\xi_0^\ell \sim \rho_0$ and $\omega_0^{\ell} \propto  \Psi_{y_0, \Sigma_y}(f_{\widehat \theta_{p-1}}(\xi^{\ell}_0))$\;
	\For{$t \gets 1$ \KwTo $T$}{
	\For{$j \gets 1$ \KwTo $N$}{
		$I_t^j \sim \mathbb{P}(I_t^j=m) = \omega_{t-1}^m$\;
		$\xi_t^j \sim p_t(\xi_{t-1}^{I_t^j},  \widetilde u_t,\cdot)$\;
		$\omega_t^j \propto  \Psi_{y_t, \Sigma_y}(f_{\widehat \theta_{p-1}}(\xi^{j}_t))$\;
		Set $\xi_{0:t}^j = (\xi_{0:t-1}^{I_t^j},\xi_t^j)$.
		}
	}
	Update the parameter estimate using gradient descent with estimated gradient $\widehat {S}^N_{\widehat \theta_{p-1}}(y_{1:T})$.
	}
\end{algorithm}

\subsection{Benchmarked models}
\subsubsection{Hidden Markov Model}
We benchmark our model against the Hidden Markov Model defined in Section~\ref{sec:hmm}.
Parameters are estimated through the Expectation Maximization algorithm.
Compared to our proposed architecture based on a deep neural network, the HMM performs poorly, as the data is strongly non linear, and present complex long term dependencies.

\subsubsection{Monte Carlo Dropout}
Dropout is a common method for regularising neural networks, that consists in randomly - and temporally - discarding connections between neurons during training, see \cite{Srivastava2014Dropout}.
It has been showed to prevent units from co-adapting.
During inference, while dropout is usually disabled, it is possible to utilize it to measure the uncertainty associated with a prediction, see \cite{Brosse2020OnLA} for a benchmark.
Multiple samples are generated independently from the network, and interpreted as a distribution.

While this idea seems promising for independent data, one does not simply apply dropout to Recurrent Neural Networks.
In \cite{Pham2014Dropout}, the authors were not able to successfully utilise dropout in the recurrent connections of their network, as it lead to instability for long sequences.
Faced with the same limitation, \cite{Moon2015Dropout} proposed to apply a fixed dropout mask to the entire sequence of latents, in order to regularise the model.
By applying a mask on the weights, rather than the latent vectors, \cite{Gal2016NIPS} proposed a theoretically grounded application of dropout for recurrent networks, that extends to LSTM and GRU layers.
We benchmarked their methodology, named the Monte Carlo Dropout (MC Dropout).
Compared to our proposed approach, the training procedure is straightforward, however the model still suffers from overconfidence.

\subsection{Experiments}
\label{sub:lastlayer_experiments}
In this section, we detail the implementation choices of the model described above as well as the evaluation procedure.
Results on both the Relative Humidity and the Electricity Transfer datasets, presented in Section~\ref{sec:dataset_uncertainty}, are reported.

\subsubsection{Models}%
The Input model is a $L=3$ layered GRU model, as defined in the deep learning framework PyTorch\footnote{\href{https://pytorch.org/docs/stable/generated/torch.nn.GRU.html}{https://pytorch.org/docs/stable/generated/torch.nn.GRU.html}}: for all $1 \leq \ell \leq L$ and all $1 \leq t \leq T$,
\begin{align*}
	r^\ell_t        & = \sigma(W_{ir} u^{\ell - 1}_t + b_{ir} + W_{hr} u^{\ell}_{t-1} + b_{hr}) \,,                \\
	z^\ell_t        & = \sigma(W_{iz} u^{\ell - 1}_t + b_{iz} + W_{hz} u^{\ell}_{t-1} + b_{hz}) \,,                \\
	n^\ell_t        & = \mathrm{tanh}(W_{in} u^{\ell - 1}_t + b_{in} + r^\ell_t (W_{hn} u^\ell_{t-1} + b_{hn}))\,, \\
	\tilde u^\ell_t & = (1-z^\ell_t) n^\ell_t+z^\ell_t u^\ell_{t-1}\,,
\end{align*}
where $\phi = \{(W_{is}, b_{is}, W_{hs}, b_{hs}), s \in \{r, z, n\}\}$ are unknown parameters, and $\sigma: x \mapsto 1/(1+\mathrm{e}^{-x})$ is the sigmoid function.
The first layer of the network is assimilated to the input vectors, $\widetilde u_t^0 \equiv u_t$ and $\widetilde u^\ell_0 \equiv 0$.
% where $\phi = \{W_{ir}, b_{ir}, W_{hr}, b_{hr}, W_{iz}, b_{iz}, W_{hz}, b_{hz}, W_{in}, b_{in}, W_{hn}, b_{hn}\}$ are unknown parameters
The input dimension $d_\textnormal{in}$ corresponds to the number of exogenous input variables of the dataset: $d_\textnormal{in}=3$ for the Relative Humidity dataset and $d_\textnormal{in}=6$ for the Electricity Transformer dataset.
The output dimension is set to $6$ for both.
In order to estimate the parameters $\phi$, we introduce an auxiliary GRU layer responsible for modelling observations.
During the training, we minimize the cost function $\mathcal{L}_{\mathrm{input}}(\phi) = \sum_{i=1}^{N_{\texttt{sample}}} \|\texttt{model}_{\phi}(u^i_{1:T}) - y^i_{1:T}\|^2$ where for each sample $1 \leq i \leq N_{\texttt{sample}}$ in the dataset, $\texttt{model}_\phi(u^i_{1:T})$ is the prediction associated with $y^i_{1:T}$ obtained with this deterministic model.

The State Space model is implemented using PyTorch implementations of RNN and Linear layers, in order to use auto differentiation.
We chose the following form for $f_\theta$ and $g_\theta$:
\begin{align*}
	g_\theta & : x_{t-1}, \widetilde u_t \mapsto \tanh(W_{gx} x_{t-1} + b_{gx} + W_{gu} \widetilde u_t + b_{gu})\,, \\
	f_\theta & : x_t \mapsto  \sigma(W_f x_t + b_f)\,,
\end{align*}
where $\theta = \{W_{gx}, b_{gx}, W_{gu}, b_{gu}, W_f, b_f\}$ are unknown parameters.

In these settings, the formula for updating both $\Sigma_x$ and $\Sigma_y$ is available explicitly, by directly deriving \ref{eq:grad_ll}.
Instead of relying on gradient descent, we simply update both matrix at each time step by computing the following:
\begin{align*}
	\Sigma_x & = T^{-1} \sum_{\ell=1}^N \sum_{t=1}^T \omega_T^\ell (\tanh^{-1}(\xi_t^\ell) - g_{\hat \theta}(\xi^\ell_{t-1}, \widetilde u_t))^2\,, \\
	\Sigma_y & = T^{-1} \sum_{\ell=1}^N \sum_{t=1}^T \omega_T^\ell (y_t - f_{\hat \theta}(\xi^\ell_t))^2 \,.
\end{align*}

All following experiments were conducted with $N=100$ particles, using the Adam optimizer introduced in \cite{Kingma2015AdamAM}.
The learning rate and batch size were chosen using a Tree-structured Parzen Estimator algorithm, see \cite{Bergstra2011HPOptimization}.
We train models for a maximum of 50 epochs, and employ early stopping to prevent overfit.

\subsubsection{Evaluations}%
In this section, we illustrate the ability of our model to capture the distribution of future observations, by evaluating the benchmarked models using the following protocol. We draw 48 hours long samples $(u_{1:48}, y_{1:48})$ from the validation dataset, composed of a 24 hour long lookback window $(u_{1:24}, y_{1:24})$, containing historic commands and observations, and a predictions window where only future commands are available $(u_{25:48})$.
Each model produces a 24 hour long forecast, which is compared to the ground truth to compute the Root Mean Squared Error (RMSE) and Mean Absolute Error (MAE) criteria reported in Table~\ref{tab:lastlayer_benchmark_rhdataset} for the Relative Humidity dataset and Table~\ref{tab:lastlayer_benchmark_etdataset} for the Electricity Transformer dataset.

Predictions can be performed by approximating the predictive density $p_{\theta,\phi}(y_{t+1}|u_{1:t+1},y_{1:t})$ by:
$$
	p^N_{\widehat\theta,\widehat\phi}(y_{t+1})= \sum_{i=1}^{N}\omega_t^i p_{\widehat\theta,\widehat\phi}(y_{t+1}|\xi_t^i,u_{t+1})\,,
$$
where $ p_{\widehat\theta,\widehat\phi}(y_{t+1}|\xi_t^i,u_{t+1})$ is the predictive distribution of $y_{t+1}$ described in Section~\ref{sub:lastlayer_proposed_architecture}.
Although predictions given the previous time step provide good performance, it is limited as many applications require multi-steps forecasts.
In order to explore longer ranges, we can simply run our model to get $N$ samples for any time horizon $p$.
Since re sampling of particles is no longer available at that point, the uncertainty grows for our model, as shown in Figure~\ref{fig:lastlayer_ci_growing}.
We report RMSE and MAE criteria by averaging the forecasts of these $N$ draws.
The associated intervals containing 95\% of the samples are displayed in Figure~\ref{fig:lastlayer_ci_rhdataset} and Figure~\ref{fig:lastlayer_ci_etdataset}, for $1\leq p \leq 24$.

We compared our model with MC Dropout methods, by implementing recurrent dropout layers as described in \cite{Gal2016NIPS}, with dropout values of $p_\textnormal{drop}=0.05$ and $p_\textnormal{drop}=0.01$.
The training procedure is similar to traditional recurrent models ; during inference, we draw $100$ samples from the dropout layers, and compute the same average forecasts and  intervals as for our model.
Despite being based on the same deep learning architecture, the MC dropout model is still largely overconfident, while our proposed model provide more credible empirical confidence intervals.
It also outperforms the Hidden Markov Model introduced in Section~\ref{sec:hmm}, see Table~\ref{tab:lastlayer_benchmark_rhdataset}.

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity given observations in the lookback window ($t<24$) and without ($t>24$).
		Since re sampling of particles is no longer available after $t=24$, the uncertainty grows as the confidence intervals get larger over time.
		In the absence of specific initialization rules, the first time step is highly uncertain, without posing a problem in the later steps.}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_growing.png}
	\label{fig:lastlayer_ci_growing}
\end{figure}

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Oil temperature (ETDataset) given observations in the lookback window ($t < 24$).
		For better clarity, we only plotted the forecast window ($t > 24$).
		As a comparison, we plotted the confidence intervals produced by the MC Dropout model (for $p_\textnormal{drop}=0.01$), whose performance are on par with our model but is still largely overconfident.
		Aggregated results on the entire validation set for the RMSE and MAE criteria can be found in Table~\ref{tab:lastlayer_benchmark_etdataset}.}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_ett_1.png}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_ett_2.png}
	\label{fig:lastlayer_ci_etdataset}
\end{figure}

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity given observations in the lookback window ($t < 24$).
		For better clarity, we only plotted the forecast window ($t > 24$).
		As a comparison, we plotted the confidence intervals produced by the MC Dropout model (for $p_\textnormal{drop}=0.01$), whose performance are on par with our model but is still largely overconfident.
		Aggregated results on the entire validation set for the RMSE and MAE criteria can be found in Table~\ref{tab:lastlayer_benchmark_rhdataset}.}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_rh_1.png}
	\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_rh_2.png}
	\label{fig:lastlayer_ci_rhdataset}
\end{figure}

\begin{table}[htpb]
	\centering
	\caption{\textbf{Electricity Transformer dataset.}
		Comparison of RMSE, MAE and computation time of our model against the benchmarked MC Dropout methods and HMM.
		This table provides aggregated results of the predictions on the entire validation set.
		Two versions of the dropout model were evaluated, with dropout values $p_\textnormal{drop}=0.05$ and $p_\textnormal{drop}=0.01$.
		Our model performs similarly to state of the art benchmarks in terms of metrics, while mitigating the overconfidence of neural networks such as the MC Dropout methods.
		Mean values of the estimators, taken over the validation samples of the dataset, are displayed along with their variance.}
	\label{tab:lastlayer_benchmark_etdataset}
	\begin{tabular}{llll}
		\toprule
		             & RMSE            & MAE             & Computation time \\
		\toprule
		SMCL (ours)  & $0.24 \pm 0.13$ & $0.21 \pm 0.12$ & $21 ms$          \\
		MCD $p=0.01$ & $0.25 \pm 0.15$ & $0.21 \pm 0.14$ & $19 ms$          \\
		MCD $p=0.05$ & $0.28 \pm 0.15$ & $0.24 \pm 0.13$ & $19 ms$          \\
		\bottomrule
	\end{tabular}
\end{table}

\begin{table}[htpb]
	\centering
	\caption{\textbf{Relative Humidity dataset.}
		Comparison of RMSE, MAE and computation time of our model against the benchmarked MC Dropout methods and HMM.
		This table provides aggregated results of the predictions on the entire validation set.
		Two versions of the dropout model were evaluated, with dropout values $p_\textnormal{drop}=0.05$ and $p_\textnormal{drop}=0.01$.
		Our model performs similarly to state of the art benchmarks in terms of metrics, while mitigating the overconfidence of neural networks such as the MC Dropout methods.
		Mean values of the estimators, taken over the validation samples of the dataset, are displayed along with their variance.}
	\label{tab:lastlayer_benchmark_rhdataset}
	\begin{tabular}{llll}
		\toprule
		             & RMSE            & MAE             & Computation time \\
		\toprule
		SMCL (ours)  & $0.30 \pm 0.19$ & $0.26 \pm 0.16$ & $21 ms$          \\
		MCD $p=0.01$ & $0.29 \pm 0.18$ & $0.25 \pm 0.16$ & $19 ms$          \\
		MCD $p=0.05$ & $0.35 \pm 0.22$ & $0.30 \pm 0.20$ & $19 ms$          \\
		HMM          & $0.46 \pm 0.19$ & $0.40 \pm 0.17$ & $99 ms$          \\
		\bottomrule
	\end{tabular}
\end{table}

\subsection{Discussion}%
We introduced a decoupled architecture for uncertainty estimation applied to dependant data, and evaluated our methodology on two time series datasets.
Our deep neural network backbone is able to extract high level features, while particle filtering allows modelling recurrent non linear uncertainty.
Our proposed model improves confidence interval quality, compared to MC Dropout methods, without degrading RMSE or MAE criteria.

We demonstrated the potential behind implementing latent space models as a modified RNN cell ; more complex architectures, such as the GRU network used in the input model, or LSTM cells, have the potential to model more complex and long term uncertainty.
Likewise, the Path-space smoother could be replaced by more recent alternatives, such as the Forward Filtering Backward Smoothing \cite{Doucet2000OnSM} or the Forward Filtering Backward Simulation algorithm \cite{Godsill2004MonteCS}, which mitigate particle degeneracy at the cost of heavier computations.
These potential improvements are left for future works.

Our decoupled architecture also enables incorporating uncertainty estimation to an already trained network, by simply adding our last layer.
Estimating its parameters would be cheaper than training an entire new uncertainty estimation model, as only the second stage training would be required.
In a context where our computational budget is constraint, online smoother such as the PaRIS algorithm \cite{Olsson2014EfficientPO,gloaguen2022pseudo}, could also offer a very efficient method for recalibrating our parameters over large period of time, such as in the case of Oze-Energies.

\paragraph{Applications for Oze-Energies. }
The data gathered by Oze-Energies is quite complex.
Even considering Relative Humidity only, our architecture still struggles to precisely model the daily evolution of the building, as seen in the previous section.
This is made even more complex as data is scarce, and building's behavior greatly vary from season to season.

A promising methodology to address this complex modelling problem consists in training a global model on the entire available dataset, then estimating fine-tuned models for each month, or season.
This way, while the global behavior over the year can be assimilated in a first stage training, specific aspects could be fine-tuned on restricted fractions of the dataset.
Our decoupled architecture shines is this context, as different uncertainty levels could easily be derived for different parts of the year.

\subsection{Limitations of a continuous latent space for time series}
The main limitation of SMC in our use case is the difficulty to infer parameters.
Even in the case of the simple Path-space smoother, computation costs are much heavier than traditional neural network architectures such as MC Dropout, and better alternatives to this smoother would likely only increase this gap.
Additionally, each modification of the model requires rewriting the loss function.

For this reason, we decide to experiment on discrete latent, which are much simpler to model for time series as they do not require sampling and re sampling at each time step.
The models we present in the following section offer lighter training procedures, and more appealing computational costs, without loosing in precision.

% =================== VADILTIS ===================
\section{Variational approaches for discrete latent states}
\label{sec:chap2-vadiltis}

\subsection{Introduction}
Discrete latent space models aim at representing data through a finite set of features.
Recent advances in generative models have pushed towards these representations, as they fit data with naturally discrete hidden states.
For instance, defining a classification task over a dataset often implies a partition of an unobserved latent space, which could be modelled using a categorical random variable, as presented in \cite{Kingma2014}.
In attention-based models, representing the focus location as a discrete variable, i.e. the right place to focus in the past for predicting the next observation, has proven efficient, and can help interpreting prediction errors, see for instance \cite{Xu2015}.
When analyzing time series data, the evolution of a discrete latent variable can be interpreted as a switch in regime, see \cite{Dzunic2014}.
In \cite{Ajib2020}, the authors model the indoor temperature of a building by identifying discrete regimes, such as the opening of a window, the presence of occupants or shade.

As one of the most widespread expression of discrete latent space models, Hidden Markov Models have been successfully applied in various fields (\cite{Wilks1998, Gales2008, Patterson2017}).
Despite modeling hidden states as a discrete Markov chain, they are able to handle complex data structure, see \cite{Cappe2005,douc2014nonlinear} and the references therein for a complete overview.
However, dealing with latent data leads to models that are computationally expensive to train, for instance using Expectation Maximization based approaches, and still struggle to handle large scale datasets, in particular when the models contain high-dimensional additional latent states.

In contrast, deep learning methods are able to infer millions of parameters from huge amounts of data - at the cost of much more complex models - through automatic differentiation and gradient computation to optimize a well chosen loss function.
However, discrete variables usually prevent us from using gradient propagation, and in turn straightforward trainings.
For instance, the Vector-Quantized Variational AutoEncoder (VQ-VAE, \cite{Oord2017}) popularized discrete latent spaces for variational inference, by introducing a new family of generative models using posterior distribution over discrete latent variables.
This approach requires various approximations in order to propagate the gradient through the model.
The reparametrization trick, only recently introduced for categorical variables with the Gumbel Softmax approximation in \cite{Jang2017}, offers an appealing solution to overcome this problem.

We propose the following contributions:
\begin{itemize}
	\item We introduce a generative model for time series, where the latent space is modelled as a discrete Markov chain, and, conditionally on the latent states, the observations follow a simple autoregressive process. Parameters are jointly estimated by Variational Inference.
	\item We compared the impact of different prior models to extract high-level features from the input data (based on convolutional and recurrent architectures) on the quality of samples.
	\item Our model outperforms the state of the art VQ-VAE both in accuracy and computation time.
\end{itemize}

\subsection{Background}
\subsubsection{Discrete latent representation}
One of the most straightforward application of discrete latent representation is derived from semi or unsupervised classification problems, where the data presents distinct semantic classes.
The authors of \cite{Kingma2014} propose to model such data as generated by both a continuous and a categorical class variable.
By integrating a classification mechanism directly in the model, they are able to outperform continuous latent models, while allowing conditional generation.
This idea was transposed to Generative Adversarial Networks by the authors of \cite{Chen2016}, by adding a discrete random variable as the input of the generator.
Trainings on the MNIST dataset, introduced in \cite{LeCun1998Mnist}, show how the model associates each value with a class of digits, even without supervision.

Discrete latent space models have proven relevant even when there is no explicit classification task.
The authors of \cite{Dzunic2014} modelled climate data by inferring a state space switching interaction model, where the transitions between a finite set of regimes are treated as interactions.
Their approach allows for exploratory pattern discovery and post-analysis by human experts.
In \cite{nguyen2017particle}, a unifying framework for Rao-Blackwellized particle smoother is introduced, where commodity market prices are modeled by a latent Markov chain.
Unlike the continuous state space model we introduced previously (see Section~\ref{sub:lastlayer_proposed_architecture}), the particle smoother is able to exploit the discrete nature of the latent space.
Examples arise in attention-based models too, which have dominated the Natural Language Processing and Computer Vision fields for the last years.
\cite{Xu2015} presents an image captioning model where attention scores parametrize a categorical random variable; by either sampling or computing its expectation, the model extracts visual features used to generate words.

Discrete representations have also successfully replaced continuous latent spaces in existing models.
In this way, the authors of \cite{Sun2020} quantized the latent features of an existing variational recurrent neural network applied to text-to-speech synthesis, and reported improved quality in generated audio samples.

\subsubsection{Introduction to Variational Inference}
Variational Inference (VI, see \cite{Jordan2004AnIT} for an introduction) is another widely used method for estimating complex statistical models.
Their posterior distribution, usually intractable, is approximated by a family of surrogate functions whose parameters are tuned along side the model parameters.
The family of functions can be chosen to be very computationally efficient, making Variational Inference an interesting alternative to Sequential Monte Carlo methods for instance.
The main challenge of VI resides in a trade-off between ease of computation and quality of the approximation.

\paragraph{Review of the literature. }
Variational Auto-Encoder (VAE), introduced in \cite{Kingma2014AutoEncodingVB}, popularized Variational Inference to statistical model inferring parameters from large datasets.
This paper notably derived an Evidence Lower Bound for the likelihood, that can be optimized through gradient descent, taking advantage once again of the automated differentiation offered by deep learning.
Its second major contribution consists in re-parametrizing samples from the posterior in order to reduce the variance of the computed gradients, see \cite{Kingma2019AnIT} for a complete overview of the model.
Several models have since improved on the original VAE, such as the Importance Weighted Auto-Encoder introduced in \cite{Burda2016ImportanceWA}, where the authors are able to derive a tighter bound using importance sampling, or the beta-VAE \cite{Higgins2017betavae}.
In this paper, a new hyper parameter $\beta$ allows to adjust latent channel capacity and independence constraints with reconstruction accuracy.

VI methods have also been successfully applied to discrete latent models.
In \cite{Salakhutdinov2009}, the authors present a methodology for training deep Boltzmann machines through variational inference using Markov chains.
\cite{Mnih2016} extends the Importance Weighted Auto-Encoder model to discrete latent variables.
\cite{petetin2021structured} proposes a regime switching Bayesian model, where the Kullback-Leibler Divergence between the posterior and the discrete prior distribution can be computed exactly.

\paragraph{Definition. }
In the following, it is assumed that the distribution of $y$ depends on a latent random variable $z$ with prior distribution denoted $\quantized \mapsto p_\theta(\quantized)$.
Therefore, the likelihood of the observation can be written, for all $y$, $p_\theta(y) = \int p_\theta(\quantized) p_\theta(y|\quantized) dz$.
Because the posterior distribution $p_\theta(z | y)$ is not tractable, we approximate it using a parametric family of tractable distributions $\{q_\phi, \phi \in \Phi\}$.
A lower bound for the loglikelihood, referred to as  Evidence Lower BOund (ELBO) $\elbo$, can be expressed as an expectation under this new distribution $q_\phi$:

\begin{align*}
	\log p_\theta(y) & = \log \expectation \left[ \frac{p_\theta(y, Z)}{q_\phi(Z | y)} \right]                                            \\
	                 & \leq \expectation \left[ \log \frac{p_\theta(y|Z) p_\theta(Z)}{q_\phi(Z | y)} \right] = \elbo_{\theta, \phi}(y)\,.
\end{align*}
All is left is to optimize $\elbo$ with respect to $\theta$ and $\phi$.
We can compute a Monte Carlo estimator of this ELBO by sampling $M > 0$ latent variables $(z^{(i)})_{i=1}^M$ under the posterior distribution $q_\phi(z|y)$:
$$\hat \elbo_{\theta,\phi}(y) = M^{-1} \sum_{i=1}^M \log \frac{p_\theta(y|z^{(i)}) p_\theta(z^{(i)})}{q_\phi(z^{(i)} | y)}\,.
$$
In practice, many numerical applications settle for a single sample from the posterior, $M=1$.
Then, we reparametrize samples $z$ from the posterior in order to propagate the gradient through the model.
We want to express $z$ as a differentiable function $g$ of the parameter $\phi$ and some independent random variable $\epsilon$, such that $z = g_\phi(y, \epsilon)$.
The expectation under the posterior can now be written under the distribution $p_\epsilon$ of $\epsilon$, and the gradient operator becomes commutative.
For any function $f$, we have:
\begin{align*}
	\nabla_\phi \expectation [f(Z)] & = \nabla_\phi \mathbb{E}_{p_\epsilon} [f(Z)]    \\
	                                & = \mathbb{E}_{p_\epsilon} \nabla_\phi [f(Z)]\,.
\end{align*}
Note that this reparametrization constraints the choice of parametric posterior distributions.

\paragraph{Comparison with Sequential Monte Carlo methods for time series. }
Sequential Monte Carlo and Variational Inference offer two different path towards approximating a complex posterior distribution.
The main advantage of VI methods reside in its computationally appealing surrogate family, and the use of the reparametrization trick allowing to reduce the variance when computation the gradient.
The trade-off for this low variance is a higher bias, as the true posterior may not be expressed within the chosen parametric family.

\subsubsection{Application to discrete latent models}
\label{sec:chap2-discrete-latent-models}
The training methodology presented in the previous chapter only applies when the reparametrized posterior function is differentiable.
As sampling discrete random variables prevent gradient propagation through the model, a workaround is required for discrete latent models to take advantage of automatic differentiation offered by modern deep learning frameworks.

Recently, a lot of new approaches to discrete latent models have been proposed, influenced by the Vector Quantized Variational Auto Encoders (VQ-VAE) introduced in \cite{Oord2017}.
In this paper, the discrete posterior distribution is defined by associating, with each observation, one of a finite set of codebooks, whose positions are learned during training in order to partition the latent space.
The main contribution of this paper is two-fold: first, it is shown that a rough approximation of the gradient of the posterior distribution allows to estimate all parameters using gradient descent; second, the training procedure is decomposed into steps.
In order to easily learn the auto encoder parameters, an uninformative prior is first considered.
Samples generated after this step cannot catch the complex dependencies that lie in the latent space.
To produce coherent samples, a complex prior model is trained on the latent space, while keeping the previously learnt parameters frozen.
Because these prior models are usually already challenging to fit on their own, most applications of the VQ-VAE have not been able to jointly train both parts of the network, see \cite{Sun2020}.

We now review alternative methods for defining a discrete posterior distribution, as well as an appropriate prior model.

\paragraph{Differentiation of the posterior.}
Sampling discrete variables from the posterior prevents gradient propagation through the model; while the authors of the VQ-VAE proposed a straight-through approximation, other approaches have addressed this issue.
In \cite{Lorberbom2019}, the model is optimized through direct loss minimization, a method that introduces additional bias and hyper parameter tuning.
Another method, introduced in \cite{Bartler2019}, leverage importance sampling to sample from the posterior, without introducing bias or new parameters.
However, a new differentiable distribution close to the posterior must be introduced, limiting its usage in general settings.
The authors of \cite{Jang2017} proposed a new differentiable distribution, approximating samples from a categorical law while being differentiable.
Although this method does introduce a new hyper parameter, it offers a very appealing trade-off.

\paragraph{Prior.}
During the second stage of the VQ-VAE training, an autoregressive prior is trained on the latent discrete space.
In the original paper, the authors chose very resource intensive models for both image \cite{Oord2016Pixelcnn} and audio \cite{Oord2018WaveNet} datasets.
However, more parsimonious prior models already yield encouraging results.
For instance, we can find in \cite{Sun2020} a comparison of different autoregressive priors on a text-to-speech task, associated with state of the art performance, using a single layered Long Short Term Memory (LSTM) network.
On the same task, the authors of \cite{Yasuda2021} were able to perform end-to-end training.
Additionally, this prior model was conditioned on text data to produce speech samples.

\subsection{Our model}
\label{sec:chap2-vadiltis-model}
We believe the methodology of the VQ-VAE to be pertinent, however the performance presented seem to heavily depend on the quality, and complexity of the prior model.
As recent research on the choice of prior models have shown encouraging results with a variety of different architectures, we propose to model our latent discrete state with a Markovian prior.
We hope to highlight the potential of modelling data with discrete states, by proposing a Hidden Markov Model whose behaviors are well known.

We define a latent state model, where we assume that the observations $(y_t)_{t=1}^T$ are independent of the commands $(u_t)_{t=1}^T$ conditionally on hidden variables $(\quantized_t)_{t=1}^T$, which take values in a discrete set of codebooks $\mathcal{E} = \{\codebook_1,\ldots,\codebook_K\}$.
For each of $1\leq k\leq K$, $\codebook_k\in\mathbb{R}^D$.
We then consider the following family of probability density functions:
\begin{equation}
	\label{eq:model}
	p_\theta(y_{1:T} | u_{1:T}) = \int p_\theta(y_{1:T} | \quantized_{1:T}) p_\theta(\quantized_{1:T} | u_{1:T}) d\quantized_{1:T}\,,
\end{equation}
depending on an unknown parameter $\theta \in \mathbb{R}^m$.

Conditionally on the commands, we assume that the latent states $\quantized_{1:T}$ are Markovian and that the conditional law of the observations depends on past latent states, so that our model is more general than Hidden Markov Models.
It also differs from other extensions of HMMs with dependencies between the observations, such as the autoregressive processes as described in \cite{Douc2004}.
In the following paragraphs, we detail the structure of the observation and prior models, as well as the choice of posterior family.
An architecture of our model is displayed in Figure~\ref{fig:vadiltis-architecture}.

\subsubsection{Codebooks}
The codebooks represents the discrete regimes our model can switch between.
Their positions in $\mathbb{R}^D$ is inferred during training, in order to provide a good partition of the space.
In our definition of the model, the number of codebooks $K$ is fixed, as it is in most related works, and considered a hyper parameter.
We kept the same value $K=32$ as from the VQ-VAE paper \cite{Oord2017}.

\subsubsection{Observation model}
We consider a Gaussian observation model, and estimate at each time step its mean and variance:
$$p_\theta(y_{1:T} | \quantized_{1:T}) = \prod_{t=1}^T \Psi_{\mu_t, \sigma_t^2} (y_t)\,,$$
where $\Psi_{\mu, \sigma^2}$ is the probability density function of a Gaussian random variable with mean vector $\mu$ and covariance matrix $\sigma^2 I_d$.
For all $1 \leq t \leq T$, $\mu_t = g_\theta^\mu(\mu_{t-1}, \quantized_{1:t-1})$ and $\sigma_t = g_\theta^\sigma(\sigma_{t-1}, \quantized_{1:t-1})$, with $\mu_{0} \equiv \sigma_0 \equiv 0$.
We discuss our choice for the parametric functions $g_\theta^\mu$ and $g_\theta^\sigma$ in Section~\ref{sec:chosen_architectures}.

\subsubsection{Prior model}
We assume that, conditionally on the commands $\command_{1:T}$, the latent state is a discrete Markov chain.
Write, for all $1\leq \ell\leq K$, $p^{\ell}_{\theta,1} = p_\theta(\quantized_1 = \codebook_\ell | \command_{1:T})$, and for all $2\leq t\leq T$ and $1\leq k,j\leq K$, $p^{k,j}_{\theta,t|t-1} = p_\theta(\quantized_t = \codebook_k | \quantized_{t-1} = \codebook_j, \command_{1:T})$.
The prior distribution is then defined as:
$$\log p_\theta(\quantized_{1:T} | \command_{1:T}) = \sum_{k=1}^K \mathds{1}_{\quantized_1 = \codebook_k} \log p^{k}_{\theta,1} + \sum_{t=2}^T \sum_{j,k=1}^K \mathds{1}_{\quantized_{t-1} = \codebook_j}\mathds{1}_{\quantized_{t} = \codebook_k} \log p_{\theta, t|t-1}^{k,j}$$

\subsubsection{Posterior distribution}
As the posterior distribution of $\quantized_{1:T}$ given $y_{1:T}$ is intractable, we use a variational approach to estimate $\theta$. In the original approach proposed by \cite{Oord2017}, the authors use an encoding function $f_\phi$, depending on an unknown parameter $\phi \in\mathbb{R}^p$, mapping the observations to a series of encoded latent variables $\encoding_{1:T} = f_\phi(y_{1:T})$. Then, the posterior is approximated by $q_\phi(\quantized_t = \codebook_k| y_{1:T}) = \mathds{1}_{\codebook_* = \codebook_k}$, where $\codebook_* = \argmin_{\codebook_\ell\in\mathcal{E}} \| \encoding_t - \codebook_\ell \|_2$. We propose, for $1 \leq k \leq K$:
\begin{align*}
	q_{\phi, t}^k = q_\phi(\quantized_t = \codebook_k | y_{1:T}) & = \softmax ( \{- \| \encoding_t - \codebook_\ell \|_2^2\}_{1 \leq \ell \leq K} )_k \\
	                                                             & \propto \exp\{ - \| \encoding_t - \codebook_k \|_2^2 \}\,.
\end{align*}
In other words, instead of selecting the closest codebook, we sample from all available codebooks with probability proportional to their distance to the current encoded latent variable.
During both training and inference, this discrete distribution encourages the exploration of the entire set of codebooks. Under the variational distribution, the latent data are assumed to be independent conditionally on the observations.

\begin{figure}[t]
	\centering
	\caption{Architecture of our proposed model.
		In order to generate samples conditional on the commands $u$, we draw from the prior model $p_\theta(\quantized_{1:T} | u_{1:T})$, then compute the associated prediction through the likelihood distribution $p_\theta(y_{1:T} | \quantized_{1:T})$.
	}
	\includegraphics[width=0.4\linewidth]{images/airq/vadiltis/archi.png}
	\label{fig:vadiltis-architecture}
\end{figure}

\subsection{Inference procedure}
The Evidence Lower BOund (ELBO) can be decomposed in three terms: for all $(\theta,\phi)$,
$$
	\elbo(\theta,\phi) = \expectation \left[\log p_\theta(y_{1:T} | \quantized_{1:T})\right]
	+ \expectation \left[\log p_\theta(\quantized_{1:T} | u_{1:T})\right]
	-\expectation \left[\log q_\phi(\quantized_{1:T} | y_{1:T}) \right]\,,
$$
where $\expectation$ designs the expectation under the posterior distribution $q_\phi(\quantized_{1:T} | y_{1:T})$.
The last term of the ELBO can be computed explicitly as follows:
$$
	\expectation [\log q_\phi (\quantized_{1:T} | y_{1:T}) ] = \sum_{t=1}^T \sum_{k=1}^K q_{\phi, t}^k \log q_{\phi, t}^k\,.
$$
We approximate the two other terms by drawing $M>0$ samples under $q_\phi$ and computing a Monte Carlo estimator.
In order for this operation to be differentiable, we use a reparametrization designed for categorical variables based on the Gumbel-Softmax distribution.

In \cite{Gumbel1955}, it is shown that we can draw samples under $q_\phi$ by computing $\argmax_{k=1}^K (log(q_\phi^k) + g_k)$, where $(g_k)_{k=1}^K$ are independent identically distributed  samples from the Gumbel distribution $G(0, 1)$ with probability density $g(x) = e^{-(x+e^{-1})}$.
The Gumbel-Softmax distribution \cite{Jang2017CategoricalRW} aims at using the $\softmax$ function as a continuous and differentiable approximation to the $\argmax$ operator.
We sample $(g_1, \ldots, g_K)$ independently from the Gumbel distribution and define, for all $1 \leq k \leq K$, $\pi_{k,t} \propto \exp((\log q_{\phi,t}^k + g_k) / \tau_t)$, where $\tau_t>0$ is the softmax temperature, allowing for a smooth interpolation between a Uniform distribution (for large values of $\tau_t$), and a Categorical distribution (for small values of $\tau_t$).
We propose to approximate the variational posterior distribution of $\quantized_t$ by the Dirac mass at $\widetilde \quantized_t = \sum_{k=1}^K \pi_{k,t} \codebook_k$.
Through re-parametrization, this method allows for differentiation of the sampled latent vector $\widetilde \quantized_t$, with respect to the codebooks $\codebook_k$, $1\leq k \leq K$, and the encodings $ \encoding_{1:T}$.
The first term of the ELBO can now be approximated by $(\theta, \phi) \mapsto M^{-1} \sum_{i=1}^M \log p_\theta(\widetilde \quantized_{1:T} | u_{1:T})$, and the second by $(\theta, \phi) \mapsto M^{-1} \sum_{i=1}^M \log p_\theta(y_{1:T} | \widetilde \quantized_{1:T})$.

Estimating $\theta$ and $\phi$ jointly can induce instability at the beginning of the training, leading to diminished performance after convergence.
As shown in \cite{Ramesh2021}, we can perform end-to-end training by penalizing the prior and posterior terms by a factor $\beta$ initialized close to zero, and then slowly increasing its value until reaching $\beta = 1$.

\subsection{Experiments}
We now report our choice of models and hyper parameters, and their performance on the Electricity Transformer and Relative Humidity datasets.
\subsubsection{Chosen architectures}
\label{sec:chosen_architectures}
Our prior model can be decomposed in two sub-networks: an input model is responsible for extracting high level features from the commands, while the autoregressive kernel computes the Markov chain transition probabilities.
This disentanglement allows us to keep the kernel simple, while still working with high level features:
\begin{align*}
	\tilde u_{1:T} & = f_\theta^\text{input\_model} (u_{1:T}) \,,                                                   \\
	h_t            & = \ker_\theta (h_{t-1}, \tilde u_{t-\Delta:t}), \, \forall 1 \leq t \leq T, \, h_0 \equiv 0\,.
\end{align*}
For the input model, we implemented a 3-layered LSTM, with the same latent dimension as the commands.
We then compared several auto regressive architectures.
\begin{itemize}
	\item A simple RNN cell was used as a benchmark, as they struggle to model long term dependencies.
	\item A Gated Recurrent Unit (GRU) cell, following results in \cite{Sun2020}. These architectures have a more refined memory representation, and have shown encouraging results in our previous benchmarks.
	\item A kernel based on causal convolutions, as proposed in \cite{Oord2018WaveNet}, where memory is replaced by an explicit dependency on the last $\Delta=25$ time steps.
\end{itemize}
For the encoder $f_\phi$ and decoder $g_\theta^{\mu, \sigma}$ parametric functions, we chose 3-layered LSTM networks as well.

Finally, we cross validated the number of codebooks using the Root-Mean-Square Error (RMSE), as described in Section~\ref{sec:evaluation} of the model, and settled for $K=8$.
The influence of each codebook on the sample generation is illustrated in Fig~\ref{fig:codebook_usage}.

We experimented with various schedules increasing $\beta$ from 0 to 1, and found that, although this penalization is necessary to estimate all parameters jointly, the choice of schedule had little influence on the model performance.
Therefore, we increase $\beta$ linearly between epochs 1 to 100, and keep $\beta=1$ for the rest of the training, which amounts to 1500 total epochs.
In all following simulations, $D=32$.

\paragraph{Benchmarked architectures. }
We compared our model to the linear Gaussian Hidden Markov Model introduced in Section~\ref{sec:hmm}, with the same number of hidden states ($K=8$).
Transition parameters of the Markov chain, as well as mean and variance of each Gaussian are estimated through Expectation Maximization, using the Baum-Welch algorithm.

We also compared our approach to the original VQ-VAE.
The architecture of the model is kept similar, to highlight the difference of methodology and training.
The main differences are therefore:
\begin{itemize}
	\item the auto encoder is trained while considering an uninformative prior ; then, we freeze the parameters of the autoencoder to estimate the parameters of the prior model.
	\item samples from the posterior distribution are drawn under a Dirac mass, as shown above. In order to compute the gradient, we use the straight-through estimator.
\end{itemize}

\subsubsection{Evaluation}
\label{sec:evaluation}
Provided a sequence of commands, our model produces samples predicting the observations.
By averaging them over each time step, we compute the RMSE of our model: let $\hat x_{1:T}^i, 1 \leq i \leq N$ be $N$ independent sequences of predictions of $x_{1:T}$, then $\text{RMSE} = (T^{-1} \sum_{t=1}^T (x_t - N^{-1} \sum_{i=1}^N \hat x_t^i)^2)^{1/2}$.
Similarly, we report the MAE.
In the following experiments, we set $N=100$.
Results on the entire validation set are displayed in Table~\ref{tab:vadiltis_benchmark_etdataset} for the Electricity Transformer dataset and Table~\ref{tab:vadiltis_benchmark_rhdataset} for the Relative Humidity dataset, compared to the HMM, the original VQ-VAE as well as the decoupled architecture presented in Section~\ref{sec:decoupled-model}.

We visualize the uncertainty of our model by plotting confidence intervals at each time step.
We draw $N=100$ samples $(\quantized_1, \cdots, \quantized_T)$ under the prior model, conditioned on a set of commands, then compute the associated predictions by drawing under $p_\theta(y_{1:T} | \quantized_{1:T})$.
The boxplots presented in Figure~\ref{fig:vadiltis_ci_rhdataset} contain 95\% of the generated samples, much like in Section~\ref{sec:decoupled-model}.

\begin{table}[htpb]
	\centering
	\caption{\textbf{Electricity Transformer dataset.} Comparison of RMSE, MAE and computation time of our model against the benchmarked VQ-VAE, HMM, as well as the decoupled architecture from the previously section.
		This table provides aggregated results of the predictions on the entire validation set.
		Our model performs similarly to state of the art benchmarks in terms of metrics.
		Mean values of the estimators, taken over the validation samples of the dataset, are displayed along with their variance.}
	\label{tab:vadiltis_benchmark_etdataset}
	\begin{tabular}{llll}
		\toprule
		           & RMSE            & MAE             & Computation time \\
		\toprule
		SMCL       & $0.24 \pm 0.13$ & $0.21 \pm 0.12$ & $21 ms$          \\
		Ours (gru) & $0.21 \pm 0.10$ & $0.17 \pm 0.09$ & $39 ms$          \\
		Ours (rnn) & $0.21 \pm 0.10$ & $0.17 \pm 0.09$ & $39 ms$          \\
		Ours (cnn) & $0.20 \pm 0.10$ & $0.16 \pm 0.09$ & $131 ms$         \\
		VQ-VAE     & $0.28 \pm 0.12$ & $0.24 \pm 0.12$ & $39 ms$          \\
		\bottomrule
	\end{tabular}
\end{table}

\begin{table}[htpb]
	\centering
	\caption{\textbf{Relative Humidity dataset.} Comparison of RMSE, MAE and computation time of our model against the benchmarked VQ-VAE, HMM, as well as the decoupled architecture from the previously section.
		This table provides aggregated results of the predictions on the entire validation set.
		Our model performs similarly to state of the art benchmarks in terms of metrics.
		Mean values of the estimators, taken over the validation samples of the dataset, are displayed along with their variance.}
	\label{tab:vadiltis_benchmark_rhdataset}
	\begin{tabular}{llll}
		\toprule
		           & RMSE            & MAE             & Computation time \\
		\toprule
		SMCL       & $0.30 \pm 0.19$ & $0.26 \pm 0.16$ & $21 ms$          \\
		Ours (gru) & $0.30 \pm 0.19$ & $0.24 \pm 0.15$ & $39 ms$          \\
		Ours (rnn) & $0.30 \pm 0.20$ & $0.25 \pm 0.17$ & $39 ms$          \\
		Ours (cnn) & $0.31 \pm 0.20$ & $0.25 \pm 0.16$ & $131 ms$         \\
		VQ-VAE     & $0.55 \pm 0.33$ & $0.51 \pm 0.32$ & $39 ms$          \\
		HMM        & $0.46 \pm 0.19$ & $0.40 \pm 0.17$ & $99 ms$          \\
		\bottomrule
	\end{tabular}
\end{table}

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity on two samples from the validation dataset.
		Compared to the Sequential Monte Carlo approach, our discrete latent model is less biased, as confirmed by the results presented in Table~\ref{tab:vadiltis_benchmark_rhdataset}.
		This new approach also allows to produce coherent confidence intervals, whose sizes are stable regardless of the length of the predicted time series.
	}
	\includegraphics[width=0.7\linewidth]{images/airq/vadiltis/ci_oze_1.png}
	\includegraphics[width=0.7\linewidth]{images/airq/vadiltis/ci_oze_2.png}
	\label{fig:vadiltis_ci_rhdataset}
\end{figure}

\begin{figure}[t!]
	\centering
	\caption{Codebook usage for a week long sample.
		We sampled $N=100$ trajectories from the prior model, and plotted the associated codebook index at each time step.
		The full line represent the observed relative humidity.
		Some of the codebooks appear to be linked to particular behaviors of the building, for instance codebook 6 matches an increase of relative humidity at the beginning of  the day.
		We could now combine such a representation with segmentation algorithms in an unsupervised setting.}
	\includegraphics[width=0.6\textwidth]{images/airq/vadiltis/codebook_usage.png}
	\label{fig:codebook_usage}
\end{figure}

\subsection{Discussion}
In this section, we explored time series modelling with discrete latent space models.
A review of the recent contributions showed that a discrete latent representation of the data can be meaningful in a wide variety of scenarios.
These models offer performance on par with their continuous counterparts, as well new ways of interpreting the model, for instance through regime segmentation.

We proposed a generative model based on the Variational Auto Encoder (VAE) architecture, where the discrete posterior distribution is approximated by a family of neural network functions.
Benchmarks were performed on two time series dataset, and show that this new model is able to consistently learn a relevant representation of the data.
We showed that the choice of prior model does impacts performance, yet even simple architectures are able to model dependencies in the latent space.
Through reparametrization, we are able to learn all parameters jointly, regardless of the number or nature of the layers composing the auto encoder and prior models.
While choosing a suitable number of codebook remains an open question, the results presented in this section confirm the relevance of a discrete representation of the data, even for complex nonlinear modelling such as indoor air quality.

The experiments conducted in this chapter also present a good comparison of Sequential Monte Carlo and Variational Inference methods in the context of dependant data.
Both allowed us to train complex networks, with thousands of parameters, and reach state of the art performance on two complex datasets.
Sequential Monte Carlo methods fit perfectly with a decoupled model architecture, which has shown its potential in many uses cases ; additionally, SMC seamlessly fit in complex real time estimation, such as online filtering.
On the other side, Variational Inference propose a computationally efficient way to train models with an absurdly high number of parameters.
In our particular case, VI allows to define a single training procedure regardless of the architecture of the auto encoder or prior model.
It also offer new research perspectives around the choice of prior models, which is explored in the next chapter.

\clearpage
\bibliographystyle{apalike}
\bibliography{src/chap2/references}
